/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "equal.h"
#include <QtGui>
#include <QtCore>

/**
	This code is experimental.
*/
Eq::Eq()
{
	ui.setupUi(this);
	connect(ui.S30, SIGNAL(valueChanged(int)), this, SLOT(onS30(int)));
	connect(ui.S60, SIGNAL(valueChanged(int)), this, SLOT(onS60(int)));
	connect(ui.S125, SIGNAL(valueChanged(int)), this, SLOT(onS125(int)));
	connect(ui.S250, SIGNAL(valueChanged(int)), this, SLOT(onS250(int)));
	connect(ui.S500, SIGNAL(valueChanged(int)), this, SLOT(onS500(int)));
	connect(ui.S1K, SIGNAL(valueChanged(int)), this, SLOT(onS1K(int)));
	connect(ui.S2K, SIGNAL(valueChanged(int)), this, SLOT(onS2K(int)));
	connect(ui.S4K, SIGNAL(valueChanged(int)), this, SLOT(onS4K(int)));
	connect(ui.S8K, SIGNAL(valueChanged(int)), this, SLOT(onS8K(int)));
	connect(ui.S16K, SIGNAL(valueChanged(int)), this, SLOT(onS16K(int)));
	connect(ui.AMP, SIGNAL(valueChanged(int)), this, SLOT(onAmp(int)));
	connect(ui.groupBox, SIGNAL(clicked(bool)), this,
	 SLOT(enableEqualizer(bool)));
	//drawChart();
}

Eq::~Eq() {}

void Eq::save()
{
	QSettings s("messer software" , "qxplayer_eq" );
	s.setValue("Enabled", ui.groupBox->isChecked());
	s.setValue("AMP", ui.AMP->value());
	s.setValue("S30", ui.S30->value());
	s.setValue("S60", ui.S60->value());
	s.setValue("S125", ui.S125->value());
	s.setValue("S250", ui.S250->value());
	s.setValue("S500", ui.S500->value());
	s.setValue("S1K", ui.S1K->value());
	s.setValue("S2K", ui.S2K->value());
	s.setValue("S4K", ui.S4K->value());
	s.setValue("S8K", ui.S8K->value());
	s.setValue("S16K", ui.S16K->value());
}

void Eq::read()
{
	QSettings s("messer software" , "qxplayer_eq" );
	if(s.value("AMP").toInt() == 0)
		ui.AMP->setValue(100);
	else
		ui.AMP->setValue(s.value("AMP").toInt());
	ui.S30->setValue(s.value("S30").toInt());
	ui.S60->setValue(s.value("S60").toInt());
	ui.S125->setValue(s.value("S125").toInt());
	ui.S250->setValue(s.value("S250").toInt());
	ui.S500->setValue(s.value("S500").toInt());
	ui.S1K->setValue(s.value("S1K").toInt());
	ui.S2K->setValue(s.value("S2K").toInt());
	ui.S4K->setValue(s.value("S4K").toInt());
	ui.S8K->setValue(s.value("S8K").toInt());
	ui.S16K->setValue(s.value("S16K").toInt());
	ui.groupBox->setChecked(s.value("Enabled").toBool());
	enableEqualizer(s.value("Enabled").toBool());
	//drawChart();
}

void Eq::enableEqualizer(bool enable)
{
	if(!enable)
	{
	emit eqChanged(1,0);
	emit eqChanged(2,0);
	emit eqChanged(3,0);
	emit eqChanged(4,0);
	emit eqChanged(5,0);
	emit eqChanged(6,0);
	emit eqChanged(7,0);
	emit eqChanged(8,0);
	emit eqChanged(9,0);
	emit eqChanged(10,0);
	emit ampChanged(100);
	return;
	}
	emit eqChanged(1,ui.S30->value());
	emit eqChanged(2,ui.S60->value());
	emit eqChanged(3,ui.S125->value());
	emit eqChanged(4,ui.S250->value());
	emit eqChanged(5,ui.S500->value());
	emit eqChanged(6,ui.S1K->value());
	emit eqChanged(7,ui.S2K->value());
	emit eqChanged(8,ui.S4K->value());
	emit eqChanged(9,ui.S8K->value());
	emit eqChanged(10,ui.S16K->value());
	emit ampChanged(ui.AMP->value());
}

void Eq::onS30(int v)
{
	emit eqChanged(1, v);
	//drawChart();
}

void Eq::onS60(int v)
{
	emit eqChanged(2, v);
	//drawChart();

}

void Eq::onS125(int v)
{
	emit eqChanged(3, v);
	//drawChart();

}

void Eq::onS250(int v)
{
	emit eqChanged(4, v);
	//drawChart();

}

void Eq::onS500(int v)
{
	emit eqChanged(5, v);
//	drawChart();

}

void Eq::onS1K(int v)
{
	emit eqChanged(6, v);
//	drawChart();

}

void Eq::onS2K(int v)
{
	emit eqChanged(7, v);
//	drawChart();

}

void Eq::onS4K(int v)
{
	emit eqChanged(8, v);
//	drawChart();

}

void Eq::onS8K(int v)
{
	emit eqChanged(9, v);
	//drawChart();

}

void Eq::onS16K(int v)
{
	emit eqChanged(10, v);
//	drawChart();

}

void Eq::onAmp(int v)
{
	emit ampChanged(v);
//	drawChart();
}

void Eq::closeEvent(QCloseEvent*)
{
	emit closed();
}

void Eq::drawChart()
{
/*	QPixmap tmp(ui.chartLabel->width(), 48);
	chart = tmp;
	chart.fill(QColor("white"));
	QPainter p(&chart);
//	p.drawLine(0, chart.height() / 2 , chart.width(), chart.height() / 2);
	int __amp = int((47 / double(ui.AMP->maximum())) * ui.AMP->value());

	p.setPen(QColor("grey"));
	p.drawLine(0, 47 - __amp, 370, 47 - __amp);

	p.setPen(QColor("black"));
	const int w = int(ui.chartLabel->width()/10);
	int values[10];
	values[1]=ui.S30->value()+100;
	values[2]=ui.S60->value()+100;
	values[3]=ui.S125->value()+100;
	values[4]=ui.S250->value()+100;
	values[5]=ui.S500->value()+100;
	values[6]=ui.S1K->value()+100;
	values[7]=ui.S2K->value()+100;
	values[8]=ui.S4K->value()+100;
	values[9]=ui.S8K->value()+100;
	values[10]=ui.S16K->value()+100;

	int s30 = 47 - int((47/double(200))*values[1]);
	int s60 = 47 - int((47/double(200))*values[2]);
	int s125 = 47 - int((47/double(200))*values[3]);
	int s250 = 47 - int((47/double(200))*values[4]);
	int s500 = 47 - int((47/double(200))*values[5]);
	int s1K = 47 - int((47/double(200))*values[6]);
	int s2K = 47 - int((47/double(200))*values[7]);
	int s4K = 47 - int((47/double(200))*values[8]);
	int s8K = 47 - int((47/double(200))*values[9]);
	int s16K = 47 - int((47/double(200))*values[10]);

	p.drawPoint(0, s30);
	p.drawPoint(w, s60);

	QPainterPath path;
	path.moveTo(0,s30);
	path.cubicTo(0,s30,0,s60,w,s60);
	p.drawPath(path);

	path.moveTo(w, s60);
	path.cubicTo(w,s60,2*w,s60,2*w,s125);
	p.drawPath(path);

	path.moveTo(2*w, s125);
//	path.cubicTo(2*w,s60,3*w,s125, 3*w, s250);
	path.cubicTo(2*w, s125, 2*w, s250, 3*w, s250);
	p.drawPath(path);
	p.end();

	ui.chartLabel->setPixmap(chart);*/

}

