/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef MAINIMPL_H
#define MAINIMPL_H

#include "ui_mainimpl.h"
#include "player.h"

class QTimer;
class QFileDialog;
class QTreeWidgetItem;
class PlayListItem;
class Slider;
class Eq;
class QPixmap;
class PlayList;

class MainImpl : public QDialog
{
Q_OBJECT
public:


	MainImpl (/*QWidget *parent = 0*/);
	Slider *PlayVol;
	void saveSettings();

public slots:
	void playOrPause ();
	void stopTrack ();
	void upTrack();
	void downTrack();

private slots:
	void getPosition ();
	void setVolume ();
	void updateVol();
	void setPosition();
	void selectValue();
	void showList();
	void checkListVisible();
	void rmTrack();
	void processItem(QTreeWidgetItem* i);
	void updateTrackTitle(const QString& t);
	void play_current_item();
	void scrollLabel();
	void setEq(int, int);
	void setAmp(int);
	void eqClosed();
	void showEq();
	void onSlMoved(int);
	void onListCleared();
	void onPIndexChanged(int index);
	void setItemsBrush();
	void updateEngine();
	void onDelPressed();
/*	void onMoveUpPressed();
	void onMoveDnPressed();*/

Q_SIGNALS:
	void trackChanged(const QString&, const QString&, const QString&);
	void playerState(Player::State s);

private:
	void callTime();
	void readSettings();
	void playTrack();
	void createGUI();
	Ui_MainImpl ui;
	QTimer *timer2;
	QTimer *timer;
	Player *player;
	PlayList *list;
	Eq* eq;
	Slider *playProgr;
	QString metaInfo;
	QString title;
	QString album;
	QString artist;
	QTimer *scrollTimer;
	int scrollPos, min, sec, playIndex;
	QPixmap scrollPm;
	bool selectedItemDeleted;

protected:
	void keyPressEvent(QKeyEvent *e);
};
#endif
