/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef PLAYLIST_H
#define PLAYLIST_H

#include "ui_playlist.h"
#include "playlistwidget.h"
#include "ui_metainfo.h"
#include <xine.h>
#include "qx_string.h"
class PlayListWidget;
class PlayListItem;
class LineEdit;
class QHttp;
class QBuffer;
class QToolButton;
class preference;

class PlayList : public QMainWindow
{
Q_OBJECT

public:
	PlayList();
	Ui_PlayList ui;
	PlayListWidget *treeList;
	QLabel *currentPlay;
	void readTmpPList();
	int totalTime ;
	void updateListInfo();
	preference *prefDialog;
	QString browDir, codec;
	QToolButton *moveUp;
	QToolButton *moveDn;

public slots:
	void showDir(QTreeWidgetItem* it);
	void decodeList();

Q_SIGNALS:
	void listClosed();
	void metaInfoChanged(const QString&);
	void listCleared();
	void playIndexChanged(int);
private:
	void processTrack(const QString& path);
	QStringList scanDir(const QString&);
	QWidget* createSearchWidget();
	QString fileName;
	QLabel *lab;
	Ui_MetaInfo uim;
	LineEdit *searchL;
	QHttp *http;
	QBuffer *buff;
	QToolButton *clBt;
//	QString getTimeString(int msec);
	//bool itemMovUp, itemMovDn;
	QTimer *moveUpT;
	QTimer *moveDnT;

private slots:
	void set_codec(const QString&);
	void addTrack();
	void addDir();
	void getMetaInfo();
	void savePlayList();
	void openPlayList();
	void aboutQt();
	void about();
	void clearList();
	void saveMetaTags();
	void search(const QString& key);
	void selectAll();
	void getLyrics(int index);
	void showLyrics(bool );
	void onMoveUp();
	void onMoveDn();
	void clearSearch();
	void showPrefsWindow();
	void savePrefs(const QString&);
	void onMoveUpPressed();
	void onMoveDnPressed();
	void onMoveUpT();
	void onMoveDnT();
	void onMoveUpReleased();
	void onMoveDnReleased();

protected:
	void closeEvent(QCloseEvent*);
	xine_t * m_xine;
	xine_audio_port_t * m_port;
	xine_stream_t * m_stream;

protected slots:
	void toolBarCtl();
};

#endif
