/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "playlistwidget.h"
#include "playlistitem.h"
//Qt Includes
#include <QtGui>
#include <QtCore>




PlayListWidget::PlayListWidget(QWidget *parent) :
QTreeWidget(parent), i(0),
dragItemRow(0)
{
	createMenu();
	setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
//	setFocusPolicy(Qt::NoFocus);
	setRootIsDecorated(false);
	setIndentation(0);
	setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
	setColumnCount(5);
	setAlternatingRowColors(true);
	setAutoScroll(false);
	headerItem()->setText(0, tr("Title"));
	headerItem()->setText(1, tr("Artist"));
	headerItem()->setText(2, tr("Album"));
	headerItem()->setText(3, tr("Length"));
	headerItem()->setText(4, tr("Bitrate"));
}

void PlayListWidget::createMenu()
{

	addAct = new QAction(tr("Add file"), this);
	addAct->setIcon(QPixmap(":/images/open.png"));

	addListAct = new QAction(tr("Add Playlist"), this);
	addListAct->setIcon(QPixmap(":/images/file.png"));

	metaInfoAct = new QAction(tr("Meta Info"), this);
	metaInfoAct->setIcon(QPixmap(":/images/about.png"));

	playAct = new QAction(tr("Play"), this);
	playAct->setIcon(QPixmap(":/images/player_play.png"));

	clearAct = new QAction(tr("Clear list"), this);
	clearAct->setIcon(QPixmap(":/images/clear.png"));

	rmItem = new QAction(tr("Delete item"), this);
	rmItem->setIcon(QPixmap(":/images/remove.png"));


	contextMenu = new QMenu(this);
	contextMenu->addAction(playAct);
	contextMenu->addSeparator();
	contextMenu->addAction(addAct);
	contextMenu->addAction(addListAct);
	contextMenu->addSeparator();
	contextMenu->addAction(rmItem);
	contextMenu->addSeparator();
	contextMenu->addAction(clearAct);
	contextMenu->addAction(metaInfoAct);
	contextMenu->setTitle("Playlist menu");
}

void PlayListWidget::contextMenuEvent(QContextMenuEvent* e)
{
	contextMenu->exec(e->globalPos());
}

void PlayListWidget::setPlayedItem(int row, bool played)
{
	if(topLevelItemCount() != 0 && topLevelItem(row))
	{
	i = row;

	for (int a = 0; a<topLevelItemCount(); a++ )
	{
		for(int m = 0; m<columnCount(); m++)
		topLevelItem(a)->setBackground(m, Qt::NoBrush);
	}

	if(played == true)
	{
		for(int m = 0; m<columnCount(); m++)
		topLevelItem(row)->setBackground(m, QBrush(QColor(135, 206, 255), Qt::SolidPattern));
	}
	else
	{
		for(int m = 0; m<columnCount(); m++)
		topLevelItem(row)->setBackground(m, QBrush(QColor("darkgray"),
		 Qt::SolidPattern));
	}

	}
}

void PlayListWidget::keyPressEvent(QKeyEvent* e)
{
	QTreeWidget::keyPressEvent(e);
	if(e->key() == Qt::Key_Delete)
		emit deletePressed();
}
