/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef PLAYLISTWIDGET_H
#define PLAYLISTWIDGET_H

#include <QTreeWidget>
#include <QDropEvent>
//#include <QDragEvent>

class QAction;
class QMenu;
class QContextMenuEvent;
class PlayListItem;
class QKeyEvent;

class PlayListWidget : public QTreeWidget
{
	Q_OBJECT
public:
	PlayListWidget(QWidget *parent);
	QAction *addAct;
	QAction *addListAct;
	QAction *metaInfoAct;
	QAction *playAct;
	QAction *rmItem;
	QAction *clearAct;
	int i;
	inline int playedItemRow() { return i; }
	void setPlayedItem(int row, bool played);

Q_SIGNALS:
	void itemDropped(int);
	void deletePressed();

private:
	QMenu *contextMenu;
//	QTreeWidgetItem * tmpItem;
	void createMenu();
	int dragItemRow;
	int pos;

protected:
	void contextMenuEvent(QContextMenuEvent* e);
	void keyPressEvent(QKeyEvent* e);
};

#endif
