/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "preference.h"
//---------------------------------------------------------
#include <QtGui>
#include <QtCore>
//---------------------------------------------------------
preference::preference(QWidget *parent)
	: QDialog(parent)
{
	setupUi(this);
	framelist->setCurrentItem(framelist->item(0));
/**
Get output modules list
*/
	module->addItem("auto");
	m_xine = xine_new();
	xine_init(m_xine);
	const char* const* drivers = xine_list_audio_output_plugins(m_xine);
	for(int i = 0; drivers[i]; i++)
	{
		if(qstrcmp(drivers[i],"none") != 0)
		module->addItem(drivers[i]);
	}

	xine_ver->setText(QString(tr("XINE library version: %1"))
		.arg(xine_get_version_string ()));
	xine_exit(m_xine);
/** */
 
	connect(buttonBox, SIGNAL(accepted()), this, SLOT(onSaved()));
}
//---------------------------------------------------------
void preference::on_root_dir_b_clicked()
{
	QString name = QFileDialog::getExistingDirectory(
			this,
			tr("Open root directory"),
			QDir::homePath());

	if(name.isEmpty())
		return;

	root_dir_e->setText(name);
}
//---------------------------------------------------------
QString preference::rootDir()
{
	return root_dir_e->text();
}
//---------------------------------------------------------
void preference::onSaved()
{
	emit settingsSaved(root_dir_e->text());
}
//---------------------------------------------------------
void preference::on_decodeBt_clicked()
{
	emit setCodec(CSBox->currentText());
}

void preference::on_framelist_itemClicked(QListWidgetItem* it)
{
	framestack->setCurrentIndex(framelist->row(it));
}
