/***************************************************************************
*   Copyright (C) 2007 by Messer                                          *
*   neomatraz@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef TRAY_H
#define TRAY_H

#include <QSystemTrayIcon>
#include "mainimpl.h"
#include "player.h"

class QMenu;
class QAction;


class Tray : public QSystemTrayIcon
{
Q_OBJECT
public:
	Tray (QWidget *parent = 0);


private:
	MainImpl mainImpl;
	QMenu *trayMenu;
	QAction *closeAct;
	QAction *showAct;
	QAction *hideAct;
	QAction *aboutAct;
	QAction *playAct;
	QAction *stopAct;
	QAction *next;
	QAction *prev;
//	QSystemTrayIcon *trayIcon;
private slots:
	void showM ();
	void hideM ();
	void iconActivated(QSystemTrayIcon::ActivationReason);
	void quitThis ();
	void _setToolTip(const QString& art, const QString& alb, const QString& tit);
	void about();
	void setTrayIcon(Player::State);
	void onPlay();
	void onStop();
	void onPrev();
	void onNext();
};
#endif
